#import "Controller.h"

@implementation Controller

#define max(a,b) (a)>(b) ? (a) : (b)

- (void)awakeFromNib
{
    statDrawerGenerate=NO;
    statDrawerBest=NO;
    [self initTBar];
    tab=[[NSMutableArray alloc] init]; // Objet dont tu es responsable ->  supprimer dans dealloc
    dico=[[NSMutableDictionary alloc] init];
    [self loadDico];
}

// -------------------------------------------------------------------
// Dsallocation des objets trainants
// -------------------------------------------------------------------
- (void)dealloc {
    [tab release];
    [dico release];
}
// -------------------------------------------------------------------


// / / / / / / TOOLBAR 
- (void)initTBar
{
    NSToolbar *tbar=[[[NSToolbar alloc] initWithIdentifier:@"anaBar"] autorelease];
    tbarItems=[[NSMutableDictionary alloc] init]; 
    
    [self addItem:tbarItems identifier:@"generate" label:@"Gnrer" about:@"Permet de gnrer des anagrammes en cas de manque d'imagination" content:[NSImage imageNamed:@"library.icns"] act:@selector(toggleGenerateWin:)];
    [self addItem:tbarItems identifier:@"bestAna" label:@"Meilleur Anagramme" about:@"Permet de trouver le meilleur anagramme" content:[NSImage imageNamed:@"winner.icns"] act:@selector(toggleDrawerWin:)]; //findBestAnaView

    [tbar setDelegate:self];
    [tbar setAutosavesConfiguration: NO];
    [tbar setAllowsUserCustomization:NO];
    [tbar setDisplayMode: NSToolbarDisplayModeIconAndLabel];
    [anaWin setToolbar:tbar];
}

- (void)addItem:(NSMutableDictionary *)theDict identifier:(NSString *)tid label:(NSString *)lbl about:(NSString *)helpTag content:(id)view act:(SEL)action //permet d'ajouter facilement un lment
{
    NSToolbarItem *item = [[NSToolbarItem alloc] initWithItemIdentifier:tid];
    
    [item setLabel:lbl];
    [item setPaletteLabel:lbl];
    [item setToolTip:helpTag];
    [item setTarget:self ];
    [item setAction:action];
    if([view isKindOfClass:[NSImage class]])
        [item setImage:view];
    if([view isKindOfClass:[NSView class]])
    {
        [item setView:view];
        [item setMinSize:[view bounds].size];
        [item setMaxSize:[view bounds].size];
    }
    
    [theDict setObject:item forKey:tid];
}

- (NSArray *)toolbarDefaultItemIdentifiers:(NSToolbar*)toolbar //array des elements pas dfaut. envoy car I'm delegate
{
    return [NSArray arrayWithObjects:@"generate", @"bestAna",nil];
}

- (NSArray *)toolbarAllowedItemIdentifiers:(NSToolbar*)toolbar //array des elements disponible. envoy car I'm delegate
{
    return [NSArray arrayWithObjects:@"generate", NSToolbarSeparatorItemIdentifier, @"bestAna", nil];
}

- (BOOL)validateToolbarItem:(NSToolbarItem *)theItem //envoy car I'm delegate
{
    return YES;
}

- (NSToolbarItem *)toolbar:(NSToolbar *)toolbar itemForItemIdentifier:(NSString *)itemIdentifier willBeInsertedIntoToolbar:(BOOL)flag //affichage. envoy car I'm delegate
{
    return [tbarItems objectForKey:itemIdentifier];
}

// / / / / / / LAUNCHER 
- (void)MakeList:(NSString *)ana
{
    [tab removeAllObjects];
    
    MakeArray *makeArray = [[MakeArray alloc] initWithString:ana];

    [tab addObjectsFromArray:[makeArray combinaisons]];
    
    [makeArray release];
   
    [okStepTwo setHidden:NO];
}

- (void)SortList
{
    NSString *field;
    NSMutableArray *already = [[NSMutableArray alloc] init];
    register int i;
    
    for(i=[tab count]-1;i>=0;i--)
    {
        field=[[tab objectAtIndex:i] retain];
        
        if ( [self FindWord:field] && [already indexOfObject:field]==NSNotFound) {
            [already addObject:field];
        }
        
        // Plus besoin du field
        [field release];
    }
    
    [tab removeAllObjects];
    [tab addObjectsFromArray:already];
    [already release];

    
    [okStepThree setHidden:NO];
}
- (BOOL)FindWord:(NSString *)word;
{
    return ([dico objectForKey:word]!=nil);
}

- (void)ShowList
{
    [ListView reloadData];
    [okStepFour setHidden:NO];
}

// / / / / / UTILITAIRE 
- (void)loadDico
{
    NSBundle *moi=[NSBundle mainBundle];
    // -------------------------------------------------------------------
    NSString *path = [moi pathForResource:@"dictionnaire" ofType:@""];
    // -------------------------------------------------------------------
    NSArray *tmpDico;
    register int i;
    
    tmpDico = [[NSString stringWithContentsOfFile:path] componentsSeparatedByString:@"[|]"];
    
    for(i=0;i<[tmpDico count];i++)
        [dico setObject:@"dico" forKey:[tmpDico objectAtIndex:i]];
}

- (void)toggleGenerateWin:(id)sender
{
    if(statDrawerBest)
        [self toggleDrawerWin:self];
    statDrawerGenerate=!statDrawerGenerate;
    
    if(statDrawerGenerate)
        [[generateInst getDrawer] open];
    else
        [[generateInst getDrawer] close];
}
- (void)toggleDrawerWin:(id)sender
{
    if(statDrawerGenerate)
        [self toggleGenerateWin:self];
    statDrawerBest=!statDrawerBest;
    
    if(statDrawerBest)
        [findBestAnaDrawer open];
    else
        [findBestAnaDrawer close];
}

// / / / / / INTERFACE 

- (int)numberOfRowsInTableView:(NSTableView *)aTableView
{
    if(tab==NULL)
        return -1;
    return [tab count];
}
- (id)tableView:(NSTableView *)aTableView
    objectValueForTableColumn:(NSTableColumn*)aTableColumn
            row:(int)rowIndex
{
    return [tab objectAtIndex:rowIndex];
}

- (BOOL)tableView:(NSTableView *)aTableView shouldEditTableColumn:(NSTableColumn*)aTableColumn row:(int)rowInde
{
    return NO;
}

- (IBAction)actAllStepInOne:(id)sender
{
    UnsignedWide microTickCount;
    unsigned long int d1, d2, d;
    
    Microseconds(&microTickCount);
    d1=microTickCount.lo;
    
    [self MakeList:[anagrammeEntered stringValue]];
    [self SortList];
    [self ShowList];
    
    Microseconds(&microTickCount);
    d2=microTickCount.lo;
    
    d=d2-d1;
    
    [benchMark setStringValue:[NSString stringWithFormat:@"%g ms",(float)d/1000.0]];
    
}

- (IBAction)actMakeTheList:(id)sender
{
    [self MakeList:[anagrammeEntered stringValue]];
}

- (IBAction)actShowTheList:(id)sender
{
    [self ShowList];
}

- (IBAction)actSortTheList:(id)sender
{
    [self SortList];
}

-(void)controlTextDidChange:(NSNotification *)aNotification
{
    [okStepTwo setHidden:YES];
    [okStepThree setHidden:YES];
    [okStepFour setHidden:YES];	
}

- (IBAction)actGetBestAnag:(id)sender
{
    int maxLength;
    int maxFinded=0;
    NSString *maxWord = @"";
    NSString *word;
    register int i;
    NSArray *key;
    UnsignedWide microTickCount;
    unsigned long int d1, d2, d;
    
    Microseconds(&microTickCount); //BenchMark
    d1=microTickCount.lo;
    
    maxLength=[lenghtBestAnag intValue];
    key=[dico allKeys];
    
    for(i=1;i<[key count]; i++)
    {
        word=[key objectAtIndex:i];
        if(maxLength==-1 || [word length]==maxLength)
        {
            [self MakeList:word];
            [self SortList];
            maxFinded=max(maxFinded, [tab count]);
            
            if([tab count]==maxFinded)
                maxWord=word;
        }
    }
    
    [anagrammeEntered setStringValue:maxWord];
    [self actAllStepInOne:self];
    
    Microseconds(&microTickCount); //Fin BenchMark
    d2=microTickCount.lo;
    d=d2-d1;
    [benchMark setStringValue:[NSString stringWithFormat:@"%g ms",(float)d/1000.0]];
}

//ACCESSEURS
- (id)getAnaEntered
{
    return anagrammeEntered;
}

- (NSMutableDictionary *)getDico
{
    return dico;
}

//DELEGATE DRAWERS
- (BOOL)drawerShouldClose:(NSDrawer *)sender
{
    if(sender==findBestAnaDrawer)
        statDrawerBest=NO;
    else if(sender==[generateInst getDrawer])
        statDrawerGenerate=NO;
    return YES;
}
- (BOOL)drawerShouldOpen:(NSDrawer *)sender
{
    if(sender==findBestAnaDrawer)
        statDrawerBest=YES;
    else if(sender==[generateInst getDrawer])
        statDrawerGenerate=YES;
    return YES;
}

@end
